package kr.co.vividnext.sodalive.audio_content.main.v2.content

import android.annotation.SuppressLint
import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import kr.co.vividnext.sodalive.R
import kr.co.vividnext.sodalive.databinding.ItemContentMainTabContentTagBinding

class AudioContentMainTabContentTagAdapter(
    private val onClick: (String) -> Unit
) : RecyclerView.Adapter<AudioContentMainTabContentTagAdapter.ViewHolder>() {

    private val tagList = mutableListOf<String>()

    private var selectedTag = ""

    inner class ViewHolder(
        private val context: Context,
        private val binding: ItemContentMainTabContentTagBinding
    ) : RecyclerView.ViewHolder(binding.root) {
        @SuppressLint("NotifyDataSetChanged")
        fun bind(tag: String) {
            if (tag == selectedTag) {
                binding.tvTag.setBackgroundResource(
                    R.drawable.bg_round_corner_2_6_transparent_3bb9f1
                )
                binding.tvTag.setTextColor(
                    ContextCompat.getColor(context, R.color.color_3bb9f1)
                )
            } else {
                binding.tvTag.setBackgroundResource(
                    R.drawable.bg_round_corner_2_6_transparent_777777
                )
                binding.tvTag.setTextColor(
                    ContextCompat.getColor(context, R.color.color_777777)
                )
            }

            binding.tvTag.text = tag
            binding.tvTag.setOnClickListener {
                selectedTag = tag
                onClick(tag)
                notifyDataSetChanged()
            }
        }
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int) = ViewHolder(
        parent.context,
        ItemContentMainTabContentTagBinding.inflate(
            LayoutInflater.from(parent.context),
            parent,
            false
        )
    )

    override fun getItemCount() = tagList.size

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(tagList[position])
    }

    @SuppressLint("NotifyDataSetChanged")
    fun addItems(tagList: List<String>) {
        this.tagList.clear()
        this.tagList.addAll(tagList)

        if (tagList.isNotEmpty()) {
            selectedTag = tagList[0]
        }

        notifyDataSetChanged()
    }
}
